

#include <stdarg.h>

void pr(char *fmt, ... ){
        char buf[128]; // resulting string limited to 128 chars
        va_list args;
        va_start (args, fmt );
        vsnprintf(buf, 128, fmt, args);
        va_end (args);
        Serial.println(buf);

}

// Inputs
// AIN0 (pin 6) - potentiometer
// Analogue 1 - analogue in

// Outputs

// pin which drives the amplifier which drives the transmit transducer
#define OUT_PIN 3
 
#define AIN0 6
#define AIN1 7



#include <digitalWriteFast.h>

#include <SerialCommand.h>

extern void __builtin_avr_delay_cycles(unsigned long __n);




#define BUFFER_SIZE 256


volatile unsigned int buffer[BUFFER_SIZE];
volatile byte tail = 0;

unsigned int basetime;




#define USPERIOD1 193
#define USPERIOD  193




// pulse with phase change

void goping(void)
{

 noInterrupts();
 digitalWriteFast2(OUT_PIN, 1); //0
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);

 
 digitalWriteFast2(OUT_PIN, 1); //1
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);

 digitalWriteFast2(OUT_PIN, 1); //2
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //3
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //4
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 0);
 __builtin_avr_delay_cycles(USPERIOD1);


 digitalWriteFast2(OUT_PIN, 1); //5
 __builtin_avr_delay_cycles(USPERIOD1);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD1);


 
 digitalWriteFast2(OUT_PIN, 0); //6
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);

 digitalWriteFast2(OUT_PIN, 0); //7
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);

 digitalWriteFast2(OUT_PIN, 0); //8
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);


 digitalWriteFast2(OUT_PIN, 0); //9
 __builtin_avr_delay_cycles(USPERIOD);
 digitalWriteFast2(OUT_PIN, 1);
 __builtin_avr_delay_cycles(USPERIOD);


 digitalWriteFast2(OUT_PIN, 0);

 interrupts();
}



unsigned int starttime;

void dumpdata(void)
{
 unsigned int p0;
   
 for(int i=0;i<40;i++)
 {
  if(i & 1) p0=(buffer[i]-starttime-USPERIOD1) % (2*USPERIOD1);
  else      p0=(buffer[i]-starttime) % (2*USPERIOD1);
  
  pr("%u,%u",buffer[i]-starttime,p0);
 }

 Serial.flush();
}


//*** Process serial port commands

SerialCommand sCmd;



void cmdunrecognized(const char *command)
{
 Serial.println("What?"); 
}  


void cmdgetdata(void)
{
 dumpdata();
}







void loop() 
{


 ADMUX=1;                 // HCSR04 analogue output to analogue comparator
 TCCR1B |= (1<< ICES1);   //switch edge detector to detect the rise 
 delayMicroseconds(10);

 unsigned int nowtime;
 

 tail=0;

 TIMSK0 &= ~_BV(TOIE0); // disable timer0 overflow interrupt
 starttime=TCNT1;

 goping();
  
 while(1)
 {
  nowtime=TCNT1;
  if((nowtime-starttime)>5000) break;
 }

 TIMSK0 |= _BV(TOIE0); // enable timer0 overflow interrupt


 if(Serial.available()>0) 
 {
  sCmd.readSerial();
 }

 delay(100);
}



ISR(TIMER1_OVF_vect) 
{ 

}



ISR(TIMER1_CAPT_vect) 
{
 if(tail>=BUFFER_SIZE) return;
 buffer[tail++] = ICR1;

 TCCR1B^=(1<<ICES1); // toggle sense of analogue comparator event
}




 
void setup() 
{
 Serial.begin(9600);
 while (!Serial) { ; /* wait for serial port to connect. Needed for native USB */}

 sCmd.addCommand("get",cmdgetdata); 

 TCCR1A = 0x0;    // put timer1 in normal mode
 TCCR1B = 0x1;    // change prescaler to divide clock by 1

 // clear any pending capture or overflow interrupts
 TIFR1 = (1<<ICF1);

 // Enable input capture interrupt
 TIMSK1 |= (1<<ICIE1);
 
  pinMode(OUT_PIN,OUTPUT);

 pinMode(AIN0, INPUT);
 pinMode(AIN1, INPUT);
 DIDR1  |=  (1<< AIN0D);         // disable digital input buffer AIN0/1
 DIDR1  |=  (1<< AIN1D);

 ADCSRA=0; // ADC Control and Status Register A
 ADCSRB=(1<<ACME); // enable muliplxer
 ADMUX=0; // ADC Multiplexer Selection Register
 ACSR=(1<<ACIC); // Analog Comparator Input Capture by Timer/Counter 1: On
}



